﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Net.Sockets; //w3sz

namespace Moving_Forms_Test
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {

            AppDomain currentDomain = AppDomain.CurrentDomain;
            currentDomain.UnhandledException += new UnhandledExceptionEventHandler(My_Error_Handler);

            // allow a user to pass command line arguments to do things like set a non-default application data directory
            // so that multiple discrete instances of KISS Konsole could be run on the system.  Note that the installer only allows
            // one instance to be 'installed'.  But others could be created by copying the installed instance...
            string appDataDir = "";
            // NOTE: these args do NOT include the program name!
            if (args != null)
            {
                if (args.Length >= 2)
                {
                    if (args[0].ToUpper().Equals("APPDATADIR"))
                    {
                        appDataDir = args[1];
                    }
                }
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1(appDataDir));
        }

        static void My_Error_Handler(object sender, UnhandledExceptionEventArgs args)
        {
            Exception e = (Exception)args.ExceptionObject;
            Console.WriteLine("Form1_Handler caught : " + e.Message);
            Console.WriteLine("Runtime terminating: {0}", args.IsTerminating);
        }

    }
    

    public class Globals
    {
        public static readonly Size formsmallsize = new Size(600, 150);
        public static readonly Size formMicrosmallsize = new Size(720, 150);
        public static readonly Size formlargesize = new Size(1878, 500);  //was 1878,427
        public static readonly Size boxsmallsize = new Size(590, 124);
        public static readonly Size boxlargesize = new Size(1000, 288);
        public static readonly Size boxMicroBandsmallsize = new Size(114,87);
        public static readonly Point form50smallloc = new Point(0, 0);
        public static readonly Point form144smallloc = new Point(600, 0);
        public static readonly Point form222smallloc = new Point(1200, 0);
        public static readonly Point form432smallloc = new Point(0, 150);
        public static readonly Point form903smallloc = new Point(600, 150);
        public static readonly Point form1296smallloc = new Point(1200, 150);
        public static readonly Point formMicrosmallloc = new Point(0, 300);
        public static readonly Point formHFsmallloc = new Point(720, 300);
        public static readonly Point formmainloc = new Point(0, 450);
        public static readonly Point formauxloc = new Point(0, 795);   //was (0,800)
        public static readonly Point box1smallloc = new Point(0, 0);
        public static readonly Point boxMicroBandsmallloc = new Point(595, 0);
        public static readonly Point box1largeloc = new Point(0, 0);
        public static  Point form1Loc = new Point(0, 500); //was (0,1150), then (0,1145);
        public static string microband = "2304";
        public static string Your_call;
        public static int xWidth = 590;

        public static string mainradio = String.Empty;
        public static string auxradio = String.Empty;
        public static bool main50 = false;
        public static bool main144 = false;
        public static bool aux50 = false;
        public static bool aux144 = false;
        public static bool main222 = false;
        public static bool main432 = false;
        public static bool aux222 = false;
        public static bool aux432 = false;
        public static bool main903 = false;
        public static bool main1296 = false;
        public static bool aux903 = false;
        public static bool aux1296 = false;
        public static bool main2304 = false;
        public static bool aux2304 = false;
        public static bool main3456 = false;
        public static bool aux3456 = false;
        public static bool main5760 = false;
        public static bool aux5760 = false;
        public static bool main10G = false;
        public static bool aux10G = false;
        public static bool main24G = false;
        public static bool aux24G = false;
        public static bool mainMicro = false;
        public static bool auxMicro = false;
        public static bool mainHF = false;
        public static bool auxHF = false;
        public static bool digiCAT = false;
        public static bool digiCATAux = false;

        public static int BSHeight;

        public static float sidetonevol =  0.0f;
        public static int CWPitch = 600;
        public static bool sendMic = false;
        public static bool sendMicAux = false;
        public static bool sendCW = false;
        public static string w3szendpoint = string.Empty;
        public static string w3szendpoint2 = string.Empty;
        public static bool CW_dot = false;
        public static bool CW_dash = false;
        public static bool sidetonechecked = false;
        public static int rcvaudiocommandport = 8000;
        public static int rcvaudiocommandport2 = 8000;
        public static bool stopper = false;
        public static string color_scheme = "enhanced";

        public static bool once50 = false;
        public static bool once144 = false;
        public static bool once222 = false;
        public static bool once432 = false;
        public static bool once903 = false;
        public static bool once1296 = false;
        public static bool onceGHz = false;
        public static bool onceHF = false;

 //       public static Func<string, string> testFunc;
 //       public static Func<bool, bool, string, string, StringBuilder> getDigiData;
 //       public static Action<bool, string, long, long> getFA;
 //       public static Action<bool, string, long, long> getFB;
 //       public static Action<string, bool, bool> setMD;
 //       public static Func<bool, string,string, int, bool> setTx;
 //       public static Func<bool, string, string, int,bool> setRx;
    }

}
