﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Diagnostics;   // use View > Output to see debug messages
using System.IO.Ports; //w3sz
using System.Net.Sockets; //w3sz
using System.Drawing.Drawing2D;
using System.IO;
using System.Threading;
using System.Threading.Tasks;
using FragLabs.Audio.Codecs;  //w3sz This Is Opus.

namespace Moving_Forms_Test
{
    public partial class SetupForm2 : Form
    {
        IPAddress testaddress;
        
        bool suspendUpdate = false;
        double LOtest; 
        string oldN1MMPTTCOM = Properties.Settings.Default.N1MMPTTCOM;
        string oldN1MMPTTCOMAux = Properties.Settings.Default.N1MMPTTCOMAux;
        string oldDigitalPTTCOM = Properties.Settings.Default.DigitalPTTCOM;
        string oldCWInputCOM = Properties.Settings.Default.CWInputCOM;
        string oldmainN1MMCOM = Properties.Settings.Default.N1MMCOM;
        string oldauxN1MMCOM = Properties.Settings.Default.N1MMCOMLiaison;

        string oldTxAudioInBox = Properties.Settings.Default.TxAudioInName;
        string oldRxAudioOutBox = Properties.Settings.Default.RxAudioOutName;
        string oldTxDigAudioInBox = Properties.Settings.Default.DigiTxAudioInName;
        string oldRxDigAudioOutBox = Properties.Settings.Default.DigiRxAudioOutName;
        string oldTxDigAudioInBoxAux = Properties.Settings.Default.DigiTxAudioInNameAux;
        string oldRxDigAudioOutBoxAux = Properties.Settings.Default.DigiRxAudioOutNameAux;
        string oldTxN1MMAudioInBox = Properties.Settings.Default.N1MMTxAudioInName;
        string oldRxN1MMAudioOutBox = Properties.Settings.Default.N1MMRxAudioOutName;

        bool   oldHFcheckBox = Properties.Settings.Default.HFChecked;
        bool   oldcheckBox50 = Properties.Settings.Default.Checked50;
        bool   oldcheckBox144 = Properties.Settings.Default.Checked144;
        bool   oldcheckBox222 = Properties.Settings.Default.Checked222;
        bool   oldcheckBox432 = Properties.Settings.Default.Checked432;
        bool   oldcheckBox903 = Properties.Settings.Default.Checked903;
        bool   oldcheckBox1296 = Properties.Settings.Default.Checked1296;
        bool   oldGHzcheckBox = Properties.Settings.Default.GHzChecked;

        const int OPUS_BANDWIDTH_NARROWBAND = 1101; /**< 4 kHz bandpass @hideinitializer*/
        const int OPUS_BANDWIDTH_MEDIUMBAND = 1102; /**< 6 kHz bandpass @hideinitializer*/
        const int OPUS_BANDWIDTH_WIDEBAND = 1103; /**< 8 kHz bandpass @hideinitializer*/
        const int OPUS_BANDWIDTH_SUPERWIDEBAND = 1104; /**<12 kHz bandpass @hideinitializer*/
        const int OPUS_BANDWIDTH_FULLBAND = 1105; /**<20 kHz bandpass @hideinitializer*/


        private void SafeUpDownValueChange(decimal newValue, NumericUpDown control)
        {
            if (newValue < control.Minimum)
                newValue = control.Minimum;
            if (newValue > control.Maximum)
                newValue = control.Maximum;

            control.Value = newValue;
        }

        
        public SetupForm2(Form1 Parent)
        {
            InitializeComponent();


            this.FormClosing += new FormClosingEventHandler(Form_Closing);

            opusChkBox.Checked = Properties.Settings.Default.opusComp;
            opusTxChkBox.Checked = Properties.Settings.Default.opusTxComp;

            if (Properties.Settings.Default.dataBandwidth == OPUS_BANDWIDTH_NARROWBAND)
                {
                    dataBandwidth.Text = "Narrow";
                }
            else if (Properties.Settings.Default.dataBandwidth == OPUS_BANDWIDTH_MEDIUMBAND)
                {
                    dataBandwidth.Text = "Medium";
                }
            else if (Properties.Settings.Default.dataBandwidth == OPUS_BANDWIDTH_WIDEBAND)
                {
                    dataBandwidth.Text = "Wideband";
                }
            else if (Properties.Settings.Default.dataBandwidth == OPUS_BANDWIDTH_SUPERWIDEBAND)
                {
                    dataBandwidth.Text = "Superwideband";
                }
            else if (Properties.Settings.Default.dataBandwidth == OPUS_BANDWIDTH_FULLBAND)
                {
                    dataBandwidth.Text = "Fullband";
                }


            if (Properties.Settings.Default.txdataBandwidth == OPUS_BANDWIDTH_NARROWBAND)
            {
                txdataBandwidth.Text = "Narrow";
            }
            else if (Properties.Settings.Default.txdataBandwidth == OPUS_BANDWIDTH_MEDIUMBAND)
            {
                txdataBandwidth.Text = "Medium";
            }
            else if (Properties.Settings.Default.txdataBandwidth == OPUS_BANDWIDTH_WIDEBAND)
            {
                txdataBandwidth.Text = "Wideband";
            }
            else if (Properties.Settings.Default.txdataBandwidth == OPUS_BANDWIDTH_SUPERWIDEBAND)
            {
                txdataBandwidth.Text = "Superwideband";
            }
            else if (Properties.Settings.Default.txdataBandwidth == OPUS_BANDWIDTH_FULLBAND)
            {
                txdataBandwidth.Text = "Fullband";
            }

            if (Properties.Settings.Default.voiceBandwidth == OPUS_BANDWIDTH_NARROWBAND)
            {
                voiceBandwidth.Text = "Narrow";
            }
            else if (Properties.Settings.Default.voiceBandwidth == OPUS_BANDWIDTH_MEDIUMBAND)
            {
                voiceBandwidth.Text = "Medium";
            }
            else if (Properties.Settings.Default.voiceBandwidth == OPUS_BANDWIDTH_WIDEBAND)
            {
                voiceBandwidth.Text = "Wideband";
            }
            else if (Properties.Settings.Default.voiceBandwidth == OPUS_BANDWIDTH_SUPERWIDEBAND)
            {
                voiceBandwidth.Text = "Superwideband";
            }
            else if (Properties.Settings.Default.voiceBandwidth == OPUS_BANDWIDTH_FULLBAND)
            {
                voiceBandwidth.Text = "Fullband";
            }

            if (Properties.Settings.Default.txvoiceBandwidth == OPUS_BANDWIDTH_NARROWBAND)
            {
                txvoiceBandwidth.Text = "Narrow";
            }
            else if (Properties.Settings.Default.txvoiceBandwidth == OPUS_BANDWIDTH_MEDIUMBAND)
            {
                txvoiceBandwidth.Text = "Medium";
            }
            else if (Properties.Settings.Default.txvoiceBandwidth == OPUS_BANDWIDTH_WIDEBAND)
            {
                txvoiceBandwidth.Text = "Wideband";
            }
            else if (Properties.Settings.Default.txvoiceBandwidth == OPUS_BANDWIDTH_SUPERWIDEBAND)
            {
                txvoiceBandwidth.Text = "Superwideband";
            }
            else if (Properties.Settings.Default.txvoiceBandwidth == OPUS_BANDWIDTH_FULLBAND)
            {
                txvoiceBandwidth.Text = "Fullband";
            }



            dataBitrate.Text = Properties.Settings.Default.dataBitrate.ToString();
                voiceBitrate.Text = Properties.Settings.Default.voiceBitrate.ToString();
                if(Properties.Settings.Default.dataCodecIsVoip ==true)
                {
                    dataCodecType.Text = "Voip";
                }
                else
                {
                    dataCodecType.Text = "Audio";
                }
                if (Properties.Settings.Default.voiceCodecIsVoip == true)
                {
                    voiceCodecType.Text = "Voip";
                }
                else
                {
                    voiceCodecType.Text = "Audio";
                }


            txdataBitrate.Text = Properties.Settings.Default.txdataBitrate.ToString();
            txvoiceBitrate.Text = Properties.Settings.Default.txvoiceBitrate.ToString();
            if (Properties.Settings.Default.txdataCodecIsVoip == true)
            {
                txdataCodecType.Text = "Voip";
            }
            else
            {
                txdataCodecType.Text = "Audio";
            }
            if (Properties.Settings.Default.txvoiceCodecIsVoip == true)
            {
                txvoiceCodecType.Text = "Voip";
            }
            else
            {
                txvoiceCodecType.Text = "Audio";
            }


                textBox50.Text = Properties.Settings.Default.w3szendpoint50;
                textBox144.Text = Properties.Settings.Default.w3szendpoint144;
                textBox222.Text =Properties.Settings.Default.w3szendpoint222;
                textBox432.Text =Properties.Settings.Default.w3szendpoint432;
                textBox903.Text = Properties.Settings.Default.w3szendpoint903;
                textBox1296.Text =Properties.Settings.Default.w3szendpoint1296;
                textBoxGHz.Text = Properties.Settings.Default.w3szendpointGHz;
                textBoxHF.Text = Properties.Settings.Default.w3szendpointHF;
                HFcheckBox.Checked = Properties.Settings.Default.HFChecked;
                checkBox50.Checked = Properties.Settings.Default.Checked50;
                checkBox144.Checked = Properties.Settings.Default.Checked144;
                checkBox222.Checked = Properties.Settings.Default.Checked222;
                checkBox432.Checked = Properties.Settings.Default.Checked432;
                checkBox903.Checked = Properties.Settings.Default.Checked903;
                checkBox1296.Checked = Properties.Settings.Default.Checked1296;
                GHzcheckBox.Checked = Properties.Settings.Default.GHzChecked;
         
                N1MMCOMcomboBox.Click += new EventHandler(N1MMCOMcomboBox_Clicked);
                N1MMLiaisonComboBox.Click += new EventHandler(N1MMLiaisonComboBox_Clicked);
                DigitalPTTComboBox.Click += new EventHandler(DigitalPTTComboBox_Clicked);
                DigitalPTTComboBoxAux.Click += new EventHandler(DigitalPTTComboBoxAux_Clicked);
                cwInputComboBox.Click += new EventHandler(cwInputComboBox_Clicked);
                N1MMMainPTTBox.Click += new EventHandler(N1MMMainPTTBox_Clicked);
                N1MMAuxPTTBox.Click += new EventHandler(N1MMAuxPTTBox_Clicked);
                DigiCOMComboBox.Click += new EventHandler(DigiCOMComboBox_Clicked);
                DigiCOMComboBoxAux.Click += new EventHandler(DigiCOMComboBoxAux_Clicked);

                TxAudioInBox.Click += new EventHandler(TxAudioInBox_Clicked);
                RxAudioOutBox.Click += new EventHandler(RxAudioOutBox_Clicked);
                TxDigAudioInBox.Click += new EventHandler(TxDigAudioInBox_Clicked);
                RxDigAudioOutBox.Click += new EventHandler(RxDigAudioOutBox_Clicked);
                TxDigAudioInBoxAux.Click += new EventHandler(TxDigAudioInBoxAux_Clicked);
                RxDigAudioOutBoxAux.Click += new EventHandler(RxDigAudioOutBoxAux_Clicked);
                TxN1MMAudioInBox.Click += new EventHandler(TxN1MMAudioInBox_Clicked);
                RxN1MMAudioOutBox.Click += new EventHandler(RxN1MMAudioOutBox_Clicked);


                N1MMCOMcomboBox.Items.Add(Properties.Settings.Default.N1MMCOM);
                N1MMLiaisonComboBox.Items.Add(Properties.Settings.Default.N1MMCOMLiaison);
                DigitalPTTComboBox.Items.Add(Properties.Settings.Default.DigitalPTTCOM);
                DigitalPTTComboBoxAux.Items.Add(Properties.Settings.Default.DigitalPTTCOMAux);
                cwInputComboBox.Items.Add(Properties.Settings.Default.CWInputCOM);
                DigiCOMComboBox.Items.Add(Properties.Settings.Default.DigiCOM);
                DigiCOMComboBoxAux.Items.Add(Properties.Settings.Default.DigiCOMAux);
                N1MMCOMcomboBox.SelectedIndex = 0;
                N1MMLiaisonComboBox.SelectedIndex = 0;
                DigitalPTTComboBox.SelectedIndex = 0;
                DigitalPTTComboBoxAux.SelectedIndex = 0;
                cwInputComboBox.SelectedIndex = 0;
                DigiCOMComboBox.SelectedIndex = 0;
                DigiCOMComboBoxAux.SelectedIndex = 0;

                N1MMMainPTTBox.Items.Add(Properties.Settings.Default.N1MMPTTCOM);
                N1MMMainPTTBox.SelectedIndex = 0;

                N1MMAuxPTTBox.Items.Add(Properties.Settings.Default.N1MMPTTCOMAux);
                N1MMAuxPTTBox.SelectedIndex = 0;

                oldN1MMPTTCOM = Properties.Settings.Default.N1MMPTTCOM;
                oldN1MMPTTCOMAux = Properties.Settings.Default.N1MMPTTCOMAux;
                oldDigitalPTTCOM = Properties.Settings.Default.DigitalPTTCOM;
                oldCWInputCOM = Properties.Settings.Default.CWInputCOM;
            
                TxAudioInBox.Items.Add(Properties.Settings.Default.TxAudioInName);
                RxAudioOutBox.Items.Add(Properties.Settings.Default.RxAudioOutName);
                TxDigAudioInBox.Items.Add(Properties.Settings.Default.DigiTxAudioInName);
                RxDigAudioOutBox.Items.Add(Properties.Settings.Default.DigiRxAudioOutName);
                TxDigAudioInBoxAux.Items.Add(Properties.Settings.Default.DigiTxAudioInNameAux);
                RxDigAudioOutBoxAux.Items.Add(Properties.Settings.Default.DigiRxAudioOutNameAux);
                TxN1MMAudioInBox.Items.Add(Properties.Settings.Default.N1MMTxAudioInName);
                RxN1MMAudioOutBox.Items.Add(Properties.Settings.Default.N1MMRxAudioOutName);

                TxAudioInBox.SelectedIndex = 0;
                RxAudioOutBox.SelectedIndex = 0;
                TxDigAudioInBox.SelectedIndex = 0;
                RxDigAudioOutBox.SelectedIndex = 0;
                TxDigAudioInBoxAux.SelectedIndex = 0;
                RxDigAudioOutBoxAux.SelectedIndex = 0;
                TxN1MMAudioInBox.SelectedIndex = 0;
                RxN1MMAudioOutBox.SelectedIndex = 0;
            
                LO50.Text = Properties.Settings.Default.LO_50.ToString();
                LO144.Text = Properties.Settings.Default.LO_144.ToString();
                LO222.Text = Properties.Settings.Default.LO_222.ToString();
                LO432.Text = Properties.Settings.Default.LO_432.ToString();
                LO903.Text = Properties.Settings.Default.LO_903.ToString();
                LO1296.Text = Properties.Settings.Default.LO_1296.ToString();
                LO2304.Text = Properties.Settings.Default.LO_2304.ToString();
                LO3456.Text = Properties.Settings.Default.LO_3456.ToString();
                LO5760.Text = Properties.Settings.Default.LO_5760.ToString();
                LO10368.Text = Properties.Settings.Default.LO_10368.ToString();
                LO24192.Text = Properties.Settings.Default.LO_24192.ToString();

                LOOff50.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff144.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff222.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff432.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff903.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff1296.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff2304.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff3456.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff5760.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff10368.Text = Properties.Settings.Default.LOoffset_50.ToString();
                LOOff24192.Text = Properties.Settings.Default.LOoffset_50.ToString();

                Gain50MHz.Value = MicroMHz.Gain50MHz;
                Gain144MHz.Value = MicroMHz.Gain144MHz;
                Gain222MHz.Value = MicroMHz.Gain222MHz;
                Gain432MHz.Value = MicroMHz.Gain432MHz;
                Gain903MHz.Value = MicroMHz.Gain903MHz;
                Gain1296MHz.Value = MicroMHz.Gain1296MHz;
                Gain2304MHz.Value = MicroMHz.Gain2304MHz;
                Gain3456MHz.Value = MicroMHz.Gain3456MHz;
                Gain5760MHz.Value = MicroMHz.Gain5760MHz;
                Gain10368MHz.Value = MicroMHz.Gain10368MHz;
                Gain24192MHz.Value = MicroMHz.Gain24192MHz;

                Gain160m.Value = _HF.Gain160m;
                Gain80m.Value = _HF.Gain80m;
                Gain40m.Value = _HF.Gain40m;
                Gain30m.Value = _HF.Gain30m;
                Gain20m.Value = _HF.Gain20m;
                Gain17m.Value = _HF.Gain17m;
                Gain15m.Value = _HF.Gain15m;
                Gain12m.Value = _HF.Gain12m;
                Gain10m.Value = _HF.Gain10m;
                Gain6m.Value = _HF.Gain6m;
                Set_CWPitch.Value = (decimal)Globals.CWPitch;
                SidetoneVolumeTrackBar.Value = Convert.ToInt32(Globals.sidetonevol * (SidetoneVolumeTrackBar.Maximum));

                vncBox.Text = Properties.Settings.Default.vncfilelocation;
                textBox1.Text = Properties.Settings.Default.vncpassword;
                waterfallPallet.Text = Globals.color_scheme;
            
        }

        private void textBox50_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBox50.Text, out testaddress));

            if (test == true)
            {
                _50MHz.w3szendpoint1 = textBox50.Text;
                Properties.Settings.Default.w3szendpoint50 = textBox50.Text;
                Properties.Settings.Default.Save();
            }
        }

        private void textBox144_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBox144.Text, out testaddress));

            if (test == true)
            {
                _144MHz.w3szendpoint1 = textBox144.Text;
                Properties.Settings.Default.w3szendpoint144 = textBox144.Text;
                Properties.Settings.Default.Save();
            }
        }

        private void textBox222_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBox222.Text, out testaddress));

            if (test == true)
            {
                _222MHz.w3szendpoint1 = textBox222.Text;
                Properties.Settings.Default.w3szendpoint222 = textBox222.Text;
                Properties.Settings.Default.Save();
            }

        }

        private void textBox432_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBox432.Text, out testaddress));

            if (test == true)
            {
                _432MHz.w3szendpoint1 = textBox432.Text;
                Properties.Settings.Default.w3szendpoint432 = textBox432.Text;
                Properties.Settings.Default.Save();
            }

        }

        private void textBox903_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBox903.Text, out testaddress));

            if (test == true)
            {
                _903MHz.w3szendpoint1 = textBox903.Text;
                Properties.Settings.Default.w3szendpoint903 = textBox903.Text;
                Properties.Settings.Default.Save();
            }

        }

        private void textBox1296_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBox1296.Text, out testaddress));

            if (test == true)
            {
                _1296MHz.w3szendpoint1 = textBox1296.Text;
                Properties.Settings.Default.w3szendpoint1296 = textBox1296.Text;
                Properties.Settings.Default.Save();
            }

        }

        private void textBoxGHz_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBoxGHz.Text, out testaddress));

            if (test == true)
            {
                MicroMHz.w3szendpoint1 = textBoxGHz.Text;
                Properties.Settings.Default.w3szendpointGHz = textBoxGHz.Text;
                Properties.Settings.Default.Save();
            }

        }

        private void textBoxHF_TextChanged(object sender, EventArgs e)
        {
            bool test = (IPAddress.TryParse(textBoxHF.Text, out testaddress));

            if (test == true)
            {
                _HF.w3szendpoint1 = textBoxHF.Text;
                Properties.Settings.Default.w3szendpointHF = textBoxHF.Text;
                Properties.Settings.Default.Save();
            }
        }

        public void N1MMCOMcomboBox_Clicked(object Sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            N1MMCOMcomboBox.Items.AddRange(ports);
        }

        private void N1MMCOMcomboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for N1MMCOM is " + N1MMCOMcomboBox.SelectedItem.ToString());
                Properties.Settings.Default.N1MMCOM = N1MMCOMcomboBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }

        }


        public void N1MMLiaisonComboBox_Clicked(object Sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            N1MMLiaisonComboBox.Items.AddRange(ports);
        }

        private void N1MMLiaisonComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for N1MM Liaison COM is " + N1MMLiaisonComboBox.SelectedItem.ToString());
                Properties.Settings.Default.N1MMCOMLiaison = N1MMLiaisonComboBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }
        }
            //start Digi ComboBox Section

        public void DigiCOMComboBox_Clicked(object Sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            DigiCOMComboBox.Items.AddRange(ports);
        }


        public void DigiCOMComboBoxAux_Clicked(object Sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            DigiCOMComboBoxAux.Items.AddRange(ports);
        }

        private void DigiCOMComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for DigiCOM is " + DigiCOMComboBox.SelectedItem.ToString());
                Properties.Settings.Default.DigiCOM = DigiCOMComboBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }

        }

        
            //end Digi ComboBox Section


  

        private void LO50_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO50.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_50 = Convert.ToInt64(LO50.Text) * 1000000;
                Properties.Settings.Default.LO_50 = Convert.ToInt64(LO50.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");         
        }

        private void LO144_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO144.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_144 = Convert.ToInt64(LO144.Text) * 1000000;
                Properties.Settings.Default.LO_144 = Convert.ToInt64(LO144.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");         
        }

        private void LO222_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO222.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_222 = Convert.ToInt64(LO222.Text) * 1000000;
                Properties.Settings.Default.LO_222 = Convert.ToInt64(LO222.Text);
                Properties.Settings.Default.Save();
            }
            else
                MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO432_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO432.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LO_432 = Convert.ToInt64(LO432.Text) * 1000000;
                Properties.Settings.Default.LO_432 = Convert.ToInt64(LO432.Text);
                Properties.Settings.Default.Save();

            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO903_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO903.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LO_903 = Convert.ToInt64(LO903.Text) * 1000000;
                Properties.Settings.Default.LO_903 = Convert.ToInt64(LO903.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO1296_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO1296.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_1296 = Convert.ToInt64(LO1296.Text) * 1000000;
                Properties.Settings.Default.LO_1296 = Convert.ToInt64(LO1296.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO2304_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO2304.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_2304 = Convert.ToInt64(LO2304.Text) * 1000000;
                Properties.Settings.Default.LO_2304 = Convert.ToInt64(LO2304.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO3456_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO3456.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_3456 = Convert.ToInt64(LO3456.Text) * 1000000;
                Properties.Settings.Default.LO_3456 = Convert.ToInt64(LO3456.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO5760_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO5760.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_5760 = Convert.ToInt64(LO5760.Text) * 1000000;
                Properties.Settings.Default.LO_5760 = Convert.ToInt64(LO5760.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO10368_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO10368.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_10368 = Convert.ToInt64(LO10368.Text) * 1000000;
                Properties.Settings.Default.LO_10368 = Convert.ToInt64(LO10368.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");      
        }

        private void LO24192_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LO24192.Text, out LOtest);
            if (test)
            {
                MicroMHz.LO_24192 = Convert.ToInt64(LO24192.Text) * 1000000;
                Properties.Settings.Default.LO_24192 = Convert.ToInt64(LO24192.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in MHz");
        }

        private void LOOff50_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff50.Text, out LOtest);
            if (test)
            {
                MicroMHz.LOoffset_50 = Convert.ToInt64(LOOff50.Text);
                Properties.Settings.Default.LOoffset_50 = Convert.ToInt64(LOOff50.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff144_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff144.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_144 = Convert.ToInt64(LOOff144.Text);
                Properties.Settings.Default.LOoffset_144 = Convert.ToInt64(LOOff144.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff222_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff222.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_222 = Convert.ToInt64(LOOff222.Text);
                Properties.Settings.Default.LOoffset_222 = Convert.ToInt64(LOOff222.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff432_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff432.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_432 = Convert.ToInt64(LOOff432.Text);
                Properties.Settings.Default.LOoffset_432 = Convert.ToInt64(LOOff432.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff903_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff903.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_903 = Convert.ToInt64(LOOff903.Text);
                Properties.Settings.Default.LOoffset_903 = Convert.ToInt64(LOOff903.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff1296_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff1296.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_1296 = Convert.ToInt64(LOOff1296.Text);
                Properties.Settings.Default.LOoffset_1296 = Convert.ToInt64(LOOff1296.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff2304_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff2304.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_2304 = Convert.ToInt64(LOOff2304.Text);
                Properties.Settings.Default.LOoffset_2304 = Convert.ToInt64(LOOff2304.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff3456_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff3456.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_3456 = Convert.ToInt64(LOOff3456.Text);
                Properties.Settings.Default.LOoffset_3456 = Convert.ToInt64(LOOff3456.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff5760_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff5760.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_5760 = Convert.ToInt64(LOOff5760.Text);
                Properties.Settings.Default.LOoffset_5760 = Convert.ToInt64(LOOff5760.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff10368_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff10368.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_10368 = Convert.ToInt64(LOOff10368.Text);
                Properties.Settings.Default.LOoffset_10368 = Convert.ToInt64(LOOff10368.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }

        private void LOOff24192_TextChanged(object sender, EventArgs e)
        {
            bool test = Double.TryParse(LOOff24192.Text, out LOtest);
            if (test) 
            {
                MicroMHz.LOoffset_24192 = Convert.ToInt64(LOOff24192.Text);
                Properties.Settings.Default.LOoffset_24192 = Convert.ToInt64(LOOff24192.Text);
                Properties.Settings.Default.Save();
            }
            else MessageBox.Show("Must enter Frequency in Hz");
        }



        public async Task sendCommandAsync(byte[] command, string endpoint, int port)
        {
            Task task = Task.Run(() => sendCommand(command, endpoint, port));
            await task;
        }

        public void sendCommand(byte[] command, string endpoint, int port)
        {
            int commandLength = command.Length;
            //this is UI command sender; sends commands back to radio //w3sz
            UdpClient udpServer4 = new UdpClient(); //w3sz
            IPEndPoint localpt4 = new IPEndPoint(IPAddress.Parse(endpoint), port);  //w3sz  command

            udpServer4.ExclusiveAddressUse = false;  //w3sz
            udpServer4.Client.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);  //w3sz
            try
            {
                udpServer4.Client.Connect(localpt4);  //w3sz changed was client.bind Jan 2024
            }
            catch
            {
            }
            udpServer4.Send(command, commandLength, localpt4); // reply back  //w3sz 
            udpServer4.Close(); //w3sz   
        }



        private void Gain50MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain50MHz = Convert.ToInt32(Gain50MHz.Value);

            byte[] gaintextstrng = StrToByteArray("ga50" + Gain50MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(gaintextstrng, _50MHz.w3szendpoint1, 8001); 
            }
        }

        private void Gain144MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain144MHz = Convert.ToInt32(Gain144MHz.Value);
            byte[] gaintextstrng = StrToByteArray("ga14" + Gain144MHz.Value.ToString()); //w3sz  convert to byte array


            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(gaintextstrng, _144MHz.w3szendpoint1, 8002);
            }
        }

        private void Gain222MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain222MHz = Convert.ToInt32(Gain222MHz.Value);
            byte[] gaintextstrng = StrToByteArray("ga22" + Gain222MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(gaintextstrng, _222MHz.w3szendpoint1, 8003);
            }
        }

        private void Gain432MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain432MHz = Convert.ToInt32(Gain432MHz.Value);
            byte[] gaintextstrng = StrToByteArray("ga43" + Gain432MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(gaintextstrng, _432MHz.w3szendpoint1, 8004);
            }
        }

        private void Gain903MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain903MHz = Convert.ToInt32(Gain903MHz.Value);
            byte[] gaintextstrng = StrToByteArray("ga90" + Gain903MHz.Value.ToString()); //w3sz  convert to byte array
            
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(gaintextstrng, _903MHz.w3szendpoint1, 8005);
        }
        }

        private void Gain1296MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain1296MHz = Convert.ToInt32(Gain1296MHz.Value);
            byte[] gaintextstrng = StrToByteArray("g129" + Gain1296MHz.Value.ToString()); //w3sz  convert to byte array
            
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(gaintextstrng, _1296MHz.w3szendpoint1, 8006);
          }
        }

        private void Gain2304MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain2304MHz = Convert.ToInt32(Gain2304MHz.Value);
            byte[] gaintextstrng = StrToByteArray("gai2" + Gain2304MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.GHzChecked)
            {
                sendCommandAsync(gaintextstrng, MicroMHz.w3szendpoint1, 8000);
            }
        }

        private void Gain3456MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain3456MHz = Convert.ToInt32(Gain3456MHz.Value);
            byte[] gaintextstrng = StrToByteArray("gai3" + Gain3456MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.GHzChecked)
            {
                sendCommandAsync(gaintextstrng, MicroMHz.w3szendpoint1, 8000);
            }
        }

        private void Gain5760MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain5760MHz = Convert.ToInt32(Gain5760MHz.Value);
            byte[] gaintextstrng = StrToByteArray("gai5" + Gain5760MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.GHzChecked)
            {
                sendCommandAsync(gaintextstrng, MicroMHz.w3szendpoint1, 8000);
            }
        }

        private void Gain10368MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain10368MHz = Convert.ToInt32(Gain10368MHz.Value);
            byte[] gaintextstrng = StrToByteArray("gai1" + Gain10368MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.GHzChecked)
            {
                sendCommandAsync(gaintextstrng, MicroMHz.w3szendpoint1, 8000);
            }
        }

        private void Gain24192MHz_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            MicroMHz.Gain24192MHz = Convert.ToInt32(Gain24192MHz.Value);
            byte[] gaintextstrng = StrToByteArray("ga24" + Gain24192MHz.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.GHzChecked)
            {
                sendCommandAsync(gaintextstrng, MicroMHz.w3szendpoint1, 8000);
            }
        }

        public static byte[] StrToByteArray(string str)
        {
            System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
            return encoding.GetBytes(str);
        }

        private void Gain160m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain160m = Convert.ToInt32(Gain160m.Value);
            byte[] gaintextstrng = StrToByteArray("g160" + Gain160m.Value.ToString()); //w3sz  convert to byte array

            if(HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
        }
        }

        private void Gain80m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain80m = Convert.ToInt32(Gain80m.Value);
            byte[] gaintextstrng = StrToByteArray("ga80" + Gain80m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain40m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain40m = Convert.ToInt32(Gain40m.Value);
            byte[] gaintextstrng = StrToByteArray("ga40" + Gain40m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain30m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain30m = Convert.ToInt32(Gain30m.Value);
            byte[] gaintextstrng = StrToByteArray("ga30" + Gain30m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain20m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain20m = Convert.ToInt32(Gain20m.Value);
            byte[] gaintextstrng = StrToByteArray("ga20" + Gain20m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain17m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain17m = Convert.ToInt32(Gain17m.Value);
            byte[] gaintextstrng = StrToByteArray("ga17" + Gain17m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain15m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain15m = Convert.ToInt32(Gain15m.Value);
            byte[] gaintextstrng = StrToByteArray("ga15" + Gain15m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain12m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain12m = Convert.ToInt32(Gain12m.Value);
            byte[] gaintextstrng = StrToByteArray("ga12" + Gain12m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain10m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain10m = Convert.ToInt32(Gain10m.Value);
            byte[] gaintextstrng = StrToByteArray("ga10" + Gain10m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void Gain6m_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            _HF.Gain6m = Convert.ToInt32(Gain6m.Value);
            byte[] gaintextstrng = StrToByteArray("ga06" + Gain6m.Value.ToString()); //w3sz  convert to byte array

            if (HFcheckBox.Checked)
            {
                sendCommandAsync(gaintextstrng, _HF.w3szendpoint1, 8007);
            }
        }


        private void SidetoneVolumeTrackBar_Scroll(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }
            Globals.sidetonevol = (float)SidetoneVolumeTrackBar.Value / (float)SidetoneVolumeTrackBar.Maximum;
            Form1.SidetoneWaveOut.Volume = Globals.sidetonevol;
        }
        public bool CWPitchChanged;

        private void Set_CWPitch_ValueChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }
            CWPitchChanged = true;
        }

        private void Form_Closing(object sender, FormClosingEventArgs e)
        {
            if (CWPitchChanged == true)
            {
                Globals.CWPitch = Convert.ToInt32(Set_CWPitch.Value);
            }

            var o = (Form1)this.Owner;

            if (oldmainN1MMCOM != Properties.Settings.Default.N1MMCOM)
            {
                oldmainN1MMCOM = Properties.Settings.Default.N1MMCOM;
                o.mainN1MMCAT();
            }

            if (oldauxN1MMCOM != Properties.Settings.Default.N1MMCOMLiaison)
            {
                oldauxN1MMCOM = Properties.Settings.Default.N1MMCOMLiaison;
                o.auxN1MMCAT();
            }

            if (oldN1MMPTTCOM != Properties.Settings.Default.N1MMPTTCOM) 
            {
                oldN1MMPTTCOM = Properties.Settings.Default.N1MMPTTCOM;
                o.openPort3();
            }
            if (oldN1MMPTTCOMAux != Properties.Settings.Default.N1MMPTTCOMAux)
            {
                oldN1MMPTTCOMAux = Properties.Settings.Default.N1MMPTTCOMAux;
                o.openPort5();
            }
            if (oldDigitalPTTCOM != Properties.Settings.Default.DigitalPTTCOM)  
            {
                oldDigitalPTTCOM = Properties.Settings.Default.DigitalPTTCOM;
                o.openPort2(); }
            if(oldCWInputCOM != Properties.Settings.Default.CWInputCOM)   
            {
                oldCWInputCOM = Properties.Settings.Default.CWInputCOM;
                o.openPort(); }
            if (oldRxAudioOutBox != Properties.Settings.Default.RxAudioOutName) 
            {
                oldRxAudioOutBox = Properties.Settings.Default.RxAudioOutName;
                o.setRxAudioOut(); }
            if (oldRxDigAudioOutBox != Properties.Settings.Default.DigiRxAudioOutName) 
            {
                oldRxDigAudioOutBox = Properties.Settings.Default.DigiRxAudioOutName;
                o.setDigiAudioOut();
            }
            if (oldRxDigAudioOutBoxAux != Properties.Settings.Default.DigiRxAudioOutNameAux)
            {
                oldRxDigAudioOutBoxAux = Properties.Settings.Default.DigiRxAudioOutNameAux;
                o.setDigiAudioOutAux();
            }
            if (oldRxN1MMAudioOutBox != Properties.Settings.Default.N1MMRxAudioOutName) 
            { 
                oldRxN1MMAudioOutBox = Properties.Settings.Default.N1MMRxAudioOutName;
                o.setN1MMAudioOut(); }
            if (oldTxAudioInBox != Properties.Settings.Default.TxAudioInName) 
            {
                oldTxAudioInBox = Properties.Settings.Default.TxAudioInName;
                o.setTxAudioIn(); }
            if (oldTxDigAudioInBox != Properties.Settings.Default.DigiTxAudioInName) 
            {
                oldTxDigAudioInBox = Properties.Settings.Default.DigiTxAudioInName;
                o.setTxDigiAudioIn();
            }
            if (oldTxDigAudioInBoxAux != Properties.Settings.Default.DigiTxAudioInNameAux)
            {
                oldTxDigAudioInBoxAux = Properties.Settings.Default.DigiTxAudioInNameAux;
                o.setTxDigiAudioInAux();
            }
            if (oldTxN1MMAudioInBox != Properties.Settings.Default.N1MMTxAudioInName) 
            {
                oldTxN1MMAudioInBox = Properties.Settings.Default.N1MMTxAudioInName;
                o.setTxN1MMAudioIn(); }

            if ( (oldHFcheckBox != Properties.Settings.Default.HFChecked)
               || (oldcheckBox50 != Properties.Settings.Default.Checked50)
               || (oldcheckBox144 != Properties.Settings.Default.Checked144)
               || (oldcheckBox222 != Properties.Settings.Default.Checked222)
               || (oldcheckBox432 != Properties.Settings.Default.Checked432)
               || (oldcheckBox903 != Properties.Settings.Default.Checked903)
               || (oldcheckBox1296 != Properties.Settings.Default.Checked1296)
               || (oldGHzcheckBox != Properties.Settings.Default.GHzChecked))
      
            {
                 

            string bandMessage = "";
            if (Properties.Settings.Default.Checked50) { bandMessage = bandMessage + "50 "; }
            if (Properties.Settings.Default.Checked144) { bandMessage = bandMessage + "144 "; }
            if (Properties.Settings.Default.Checked222) { bandMessage = bandMessage + "222 "; }
            if (Properties.Settings.Default.Checked432) { bandMessage = bandMessage + "432 "; }
            if (Properties.Settings.Default.Checked903) { bandMessage = bandMessage + "903 "; }
            if (Properties.Settings.Default.Checked1296) { bandMessage = bandMessage + "1296 "; }
            if (Properties.Settings.Default.GHzChecked) { bandMessage = bandMessage + "Micro "; }
            if (Properties.Settings.Default.HFChecked) { bandMessage = bandMessage + "HF "; }
            Console.WriteLine("Setupform2 Bands Selected Changed and now include " + bandMessage);
                 o.selectBands();

            if ((oldHFcheckBox != Properties.Settings.Default.HFChecked) && (HFcheckBox.Checked) && (!Globals.onceHF))
            {
                o._HF.startThreads();
            }

            if ((oldGHzcheckBox != Properties.Settings.Default.GHzChecked) && (GHzcheckBox.Checked) && (!Globals.onceGHz))
            {
                o.Micro.startThreads();
            }

            if ((oldcheckBox50 != Properties.Settings.Default.Checked50) && (checkBox50.Checked) && (!Globals.once50))
            {
                o._50.startThreads();
            }

            if ((oldcheckBox144 != Properties.Settings.Default.Checked144) && (checkBox144.Checked) && (!Globals.once144))
            {
                o._144.startThreads();
            }

            if ((oldcheckBox222 != Properties.Settings.Default.Checked222) && (checkBox222.Checked) && (!Globals.once222))
            {
                o._222.startThreads();
            }

            if ((oldcheckBox432 != Properties.Settings.Default.Checked432) && (checkBox432.Checked) && (!Globals.once432))
            {
                o._432.startThreads();
            }

            if ((oldcheckBox903 != Properties.Settings.Default.Checked903) && (checkBox903.Checked) && (!Globals.once903))
            {
                o._903.startThreads();
            }

            if ((oldcheckBox1296 != Properties.Settings.Default.Checked1296) && (checkBox1296.Checked) && (!Globals.once1296))
            {
                o._1296.startThreads();
            }
                 oldHFcheckBox = Properties.Settings.Default.HFChecked;
                 oldcheckBox50 = Properties.Settings.Default.Checked50;
                 oldcheckBox144 = Properties.Settings.Default.Checked144;
                 oldcheckBox222 = Properties.Settings.Default.Checked222;
                 oldcheckBox432 = Properties.Settings.Default.Checked432;
                 oldcheckBox903 = Properties.Settings.Default.Checked903;
                 oldcheckBox1296 = Properties.Settings.Default.Checked1296;
                 oldGHzcheckBox = Properties.Settings.Default.GHzChecked;
            }
        }

        private void HFcheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.HFChecked = HFcheckBox.Checked;
            Properties.Settings.Default.Save();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = System.Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles);
            openFileDialog1.ShowDialog();
            Properties.Settings.Default.vncfilelocation = openFileDialog1.FileName;
            vncBox.Text = Properties.Settings.Default.vncfilelocation;
            Properties.Settings.Default.Save();

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.vncpassword = textBox1.Text;
            Properties.Settings.Default.Save();
        }

        
        private void cwInputComboBox_Clicked(object sender, EventArgs e)
        {

            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            cwInputComboBox.Items.AddRange(ports);

        }

        private void cwInputComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for CWInput is " + cwInputComboBox.SelectedItem.ToString());
                Properties.Settings.Default.CWInputCOM = cwInputComboBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }

        }
        
        private void waterfallPallet_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (waterfallPallet.Text == "Original")
            {
                Moving_Forms_Test.Globals.color_scheme = "original";

            }
            else if (waterfallPallet.Text == "Enhanced")
            {
                Moving_Forms_Test.Globals.color_scheme = "enhanced";

            }
            else if (waterfallPallet.Text == "Spectran")
            {
                Moving_Forms_Test.Globals.color_scheme = "SPECTRAN";

            }
            else if (waterfallPallet.Text == "BlackWhite")
            {
                Moving_Forms_Test.Globals.color_scheme = "BLACKWHITE";

            }
            else if (waterfallPallet.Text == "Linrad")
            {

                Moving_Forms_Test.Globals.color_scheme = "LinRad";
            }
            else if (waterfallPallet.Text == "Linrad Log")
            {
                Moving_Forms_Test.Globals.color_scheme = "LinLog";

            }
            else if (waterfallPallet.Text == "Linrad Auto")
            {
                Moving_Forms_Test.Globals.color_scheme = "LinAuto";

            }


        }


        private void DigitalPTTComboBox_Clicked(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            DigitalPTTComboBox.Items.AddRange(ports);
        }


        private void DigitalPTTComboBoxAux_Clicked(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            DigitalPTTComboBoxAux.Items.AddRange(ports);
        }

        private void DigitalPTTComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for DigtalPTT COM Port is " + DigitalPTTComboBox.SelectedItem.ToString());
                Properties.Settings.Default.DigitalPTTCOM = DigitalPTTComboBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }
        }

        public string[] waveInDevices;
        public string[] waveOutDevices;
        public void TxAudioInBox_Clicked(object sender, EventArgs e)
        {
           
            TxAudioInBox.Items.Clear();
            int num = Form1.micdevices.Count;
            waveInDevices = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                waveInDevices[inum] = Form1.micdevices[inum].FriendlyName;
            }
            TxAudioInBox.Items.AddRange(waveInDevices);
             

        }

        public void TxAudioInBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (TxAudioInBox.SelectedIndex >= 0)
                {
                    int inum;
                    for (inum = 0; inum < Form1.micdevices.Count; inum++ )
                        if (TxAudioInBox.SelectedItem.ToString() == Form1.micdevices[inum].FriendlyName.ToString())
                        {
                             Properties.Settings.Default.WaveInIndex = inum;
                             Properties.Settings.Default.Save();
                             Form1.waveInIndex = inum;
                             Console.WriteLine("WaveIn Index in TxAudioInBox_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("WaveIn Device Name in TxAudioInBox_SelectedIndexChanged is " + TxAudioInBox.SelectedItem.ToString());
                    Properties.Settings.Default.TxAudioInName = TxAudioInBox.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("WaveIn Device Selection Failed");
            }
        }
        
        public void RxAudioOutBox_Clicked(object sender, EventArgs e)
        {
            RxAudioOutBox.Items.Clear();
            int num = Form1.RxAudioOut.Count;
            waveOutDevices = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                waveOutDevices[inum] = Form1.RxAudioOut[inum].FriendlyName;
            }
            RxAudioOutBox.Items.AddRange(waveOutDevices);
        }

        public void RxAudioOutBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (RxAudioOutBox.SelectedIndex >= 0)
                {
                    int inum;
                    for (inum = 0; inum < Form1.RxAudioOut.Count; inum++)
                        if (RxAudioOutBox.SelectedItem.ToString() == Form1.RxAudioOut[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.WaveOutIndex = inum;
                            Properties.Settings.Default.Save();
                            Form1.waveOutIndex = inum;
                            Console.WriteLine("WaveOut Index in RxAudioInBox_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("WaveOut Device Name in RxAudioOutBox_SelectedIndexChanged is " + RxAudioOutBox.SelectedItem.ToString());
                    Properties.Settings.Default.RxAudioOutName = RxAudioOutBox.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
                }
            catch
            {
                Console.WriteLine("WaveOut Device Selection Failed");
            }
        }
        //----------------------------------------------------------------------------------

        public string[] DigiWaveInDevices;
        public string[] DigiWaveOutDevices;
        public string[] DigiWaveInDevicesAux;
        public string[] DigiWaveOutDevicesAux;
        public void TxDigAudioInBox_Clicked(object sender, EventArgs e)
        {
            TxDigAudioInBox.Items.Clear();
            int num = Form1.TxDigidevices.Count;
            DigiWaveInDevices = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                DigiWaveInDevices[inum] = Form1.TxDigidevices[inum].FriendlyName;
            }
            TxDigAudioInBox.Items.AddRange(DigiWaveInDevices);

        }


        public void TxDigAudioInBoxAux_Clicked(object sender, EventArgs e)
        {
            TxDigAudioInBoxAux.Items.Clear();
            int num = Form1.TxDigidevices.Count;
            DigiWaveInDevicesAux = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                DigiWaveInDevicesAux[inum] = Form1.TxDigidevicesAux[inum].FriendlyName;
            }
            TxDigAudioInBoxAux.Items.AddRange(DigiWaveInDevicesAux);

        }

        public void RxDigAudioOutBox_Clicked(object sender, EventArgs e)
        {
            RxDigAudioOutBox.Items.Clear();
            int num = Form1.RxDigAudioOut.Count;
            DigiWaveOutDevices = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                DigiWaveOutDevices[inum] = Form1.RxDigAudioOut[inum].FriendlyName;             
            }
            RxDigAudioOutBox.Items.AddRange(DigiWaveOutDevices);
        }


        public void RxDigAudioOutBoxAux_Clicked(object sender, EventArgs e)
        {
            RxDigAudioOutBoxAux.Items.Clear();
            int num = Form1.RxDigAudioOutAux.Count;
            DigiWaveOutDevicesAux = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                DigiWaveOutDevicesAux[inum] = Form1.RxDigAudioOutAux[inum].FriendlyName;
            }
            RxDigAudioOutBoxAux.Items.AddRange(DigiWaveOutDevicesAux);
        }

        public void TxDigAudioInBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (TxDigAudioInBox.SelectedIndex >= 0)
                {

                    int inum;
                    for (inum = 0; inum < Form1.TxDigidevices.Count; inum++)
                        if (TxDigAudioInBox.SelectedItem.ToString() == Form1.TxDigidevices[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.DigiWaveInIndex = inum;
                            Properties.Settings.Default.Save();
                            Form1.DigiWaveInIndex = inum;
                            Console.WriteLine("DigiWaveIn Index in TxDigAudioInBox_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("DigiWaveIn Device Name in TxDigAudioInBox_SelectedIndexChanged is " + TxDigAudioInBox.SelectedItem.ToString());
                    Properties.Settings.Default.DigiTxAudioInName = TxDigAudioInBox.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("WaveIn Device Selection Failed");
            }

        }
        

        public void RxDigAudioOutBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (RxDigAudioOutBox.SelectedIndex >= 0)
                {
                    int inum;
                    for (inum = 0; inum < Form1.RxDigAudioOut.Count; inum++)
                        if (RxDigAudioOutBox.SelectedItem.ToString() == Form1.RxDigAudioOut[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.DigiWaveOutIndex = inum;
                            Properties.Settings.Default.Save();
                            Form1.DigiWaveOutIndex = inum;
                            Console.WriteLine("Digi WaveOut Index in RxDigAudioInBox_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("Digi WaveOut Device Name in RxDigAudioOutBox_SelectedIndexChanged is " + RxDigAudioOutBox.SelectedItem.ToString());
                    Properties.Settings.Default.DigiRxAudioOutName = RxDigAudioOutBox.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("WaveOut Device Selection Failed");
            }
        }
        
        private void GHzcheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.GHzChecked = GHzcheckBox.Checked;
            Properties.Settings.Default.Save();
        }

        private void checkBox903_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Checked903 = checkBox903.Checked;
            Properties.Settings.Default.Save();
        }

        private void checkBox1296_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Checked1296 = checkBox1296.Checked;
            Properties.Settings.Default.Save();
        }

        private void checkBox50_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Checked50 = checkBox50.Checked;
            Properties.Settings.Default.Save();
        }

        private void checkBox144_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Checked144 = checkBox144.Checked;
            Properties.Settings.Default.Save();
        }

        private void checkBox222_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Checked222 = checkBox222.Checked;
            Properties.Settings.Default.Save();
        }

        private void checkBox432_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Checked432 = checkBox432.Checked;
            Properties.Settings.Default.Save();
        }

        //----------------------------------------------------------------------------------

        public string[] N1MMWaveInDevices;
        public string[] N1MMWaveOutDevices;
        public void TxN1MMAudioInBox_Clicked(object sender, EventArgs e)
        {
            TxN1MMAudioInBox.Items.Clear();
            int num = Form1.TxN1MMdevices.Count;
            N1MMWaveInDevices = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                N1MMWaveInDevices[inum] = Form1.TxN1MMdevices[inum].FriendlyName;
            }
            TxN1MMAudioInBox.Items.AddRange(N1MMWaveInDevices);

        }


        public void RxN1MMAudioOutBox_Clicked(object sender, EventArgs e)
        {
            RxN1MMAudioOutBox.Items.Clear();
            int num = Form1.RxN1MMAudioOut.Count;
            N1MMWaveOutDevices = new string[num];
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                N1MMWaveOutDevices[inum] = Form1.RxN1MMAudioOut[inum].FriendlyName;
            }
            RxN1MMAudioOutBox.Items.AddRange(N1MMWaveOutDevices);
        }

        private void TxN1MMAudioInBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (TxN1MMAudioInBox.SelectedIndex >= 0)
                {
                    int inum;
                    for (inum = 0; inum < Form1.TxN1MMdevices.Count; inum++)
                        if (TxN1MMAudioInBox.SelectedItem.ToString() == Form1.TxN1MMdevices[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.N1MMWaveInIndex = inum;
                            Properties.Settings.Default.Save();
                            Form1.N1MMWaveInIndex = inum;
                            Console.WriteLine("N1MMWaveIn Index in TxN1MMAudioInBox_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("N1MMWaveIn Device Name in TxN1MMAudioInBox_SelectedIndexChanged is " + TxN1MMAudioInBox.SelectedItem.ToString());
                    Properties.Settings.Default.N1MMTxAudioInName = TxN1MMAudioInBox.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("N1MM WaveIn Device Selection Failed");
            }

        }

        private void RxN1MMAudioOutBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (RxN1MMAudioOutBox.SelectedIndex >= 0)
                {
                    int inum;
                    for (inum = 0; inum < Form1.RxN1MMAudioOut.Count; inum++)
                        if (RxN1MMAudioOutBox.SelectedItem.ToString() == Form1.RxN1MMAudioOut[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.N1MMWaveOutIndex = inum;
                            Properties.Settings.Default.Save();
                            Form1.N1MMWaveOutIndex = inum;
                            Console.WriteLine("N1MM WaveOut Index in RxN1MMAudioInBox_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("N1MM WaveOut Device Name in RxN1MMAudioOutBox_SelectedIndexChanged is " + RxN1MMAudioOutBox.SelectedItem.ToString());
                    Properties.Settings.Default.N1MMRxAudioOutName = RxN1MMAudioOutBox.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("N1MM WaveOut Device Selection Failed");
            }

        }

        private void N1MMMainPTTBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for N1MM PTT COM is " + N1MMMainPTTBox.SelectedItem.ToString());
                Properties.Settings.Default.N1MMPTTCOM = N1MMMainPTTBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }


        }

        public void N1MMMainPTTBox_Clicked(object Sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            N1MMMainPTTBox.Items.AddRange(ports);
        }





        private void N1MMAuxPTTBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }
            Console.WriteLine("N1MMAuxPTTBox_SelectedIndexChanged event handler has been accessed");

            try
            {
                Console.WriteLine("The selected value for N1MM Aux PTT COM is " + N1MMAuxPTTBox.SelectedItem.ToString());
                Properties.Settings.Default.N1MMPTTCOMAux = N1MMAuxPTTBox.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }
        }

        public void N1MMAuxPTTBox_Clicked(object Sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            int num = ports.Length;
            int inum;
            for (inum = 0; inum < num; inum++)
            {
                Console.WriteLine(ports[inum].ToString());
            }
            N1MMAuxPTTBox.Items.AddRange(ports);
        }


        private void voiceBitrate_SelectedIndexChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.voiceBitrate = int.Parse(voiceBitrate.Text);
            Properties.Settings.Default.Save();


            byte[] VoiceBRtextstrng = StrToByteArray("VoBR" + voiceBitrate.Text); //w3sz  convert to byte array

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(VoiceBRtextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(VoiceBRtextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(VoiceBRtextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(VoiceBRtextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(VoiceBRtextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(VoiceBRtextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(VoiceBRtextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(VoiceBRtextstrng, _HF.w3szendpoint1, 8007);
            }
        }
 

private void voiceCodecType_SelectedIndexChanged(object sender, EventArgs e)
        {
            bool isVoip;
            if (voiceCodecType.Text == "Voip")
            {
                isVoip = true;
            }
            else
            {
                isVoip = false;
            }
                Properties.Settings.Default.voiceCodecIsVoip = isVoip;
                Properties.Settings.Default.Save();

            byte[] VoiceCodectextstrng = StrToByteArray("VoCo" + voiceCodecType.Text); //w3sz  convert to byte array

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(VoiceCodectextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(VoiceCodectextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(VoiceCodectextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(VoiceCodectextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(VoiceCodectextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(VoiceCodectextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(VoiceCodectextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(VoiceCodectextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void dataBitrate_SelectedIndexChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.dataBitrate = int.Parse(dataBitrate.Text);
                Properties.Settings.Default.Save();

            byte[] DataBRtextstrng = StrToByteArray("DaBR" +dataBitrate.Text); //w3sz  convert to byte array

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(DataBRtextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(DataBRtextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(DataBRtextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(DataBRtextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(DataBRtextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(DataBRtextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(DataBRtextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(DataBRtextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void dataCodecType_SelectedIndexChanged(object sender, EventArgs e)
        {

            bool isVoip;
            if (dataCodecType.Text == "Voip")
            {
                isVoip = true;
            }
            else
            {
                isVoip = false;
            }
            Properties.Settings.Default.dataCodecIsVoip = isVoip;
            Properties.Settings.Default.Save();

            byte[] DataCodectextstrng = StrToByteArray("DaCo" + dataCodecType.Text); //w3sz  convert to byte array

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(DataCodectextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(DataCodectextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(DataCodectextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(DataCodectextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(DataCodectextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(DataCodectextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(DataCodectextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(DataCodectextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void txvoiceBitrate_SelectedIndexChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.txvoiceBitrate = int.Parse(txvoiceBitrate.Text);
            Properties.Settings.Default.Save();
        }

        private void txvoiceCodecType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (txvoiceCodecType.Text == "Voip")
            {
                Properties.Settings.Default.txvoiceCodecIsVoip = true;
                Properties.Settings.Default.Save();
            }
            else
            {
                Properties.Settings.Default.txvoiceCodecIsVoip = false;
                Properties.Settings.Default.Save();
            }
            Console.WriteLine(Properties.Settings.Default.txvoiceCodecIsVoip);
        }
    

        private void txdataCodecType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (txdataCodecType.Text == "Voip")
            {
                Properties.Settings.Default.txdataCodecIsVoip = true;
                Properties.Settings.Default.Save();
            }
            else
            {
                Properties.Settings.Default.txdataCodecIsVoip = false;
                Properties.Settings.Default.Save();
            }
            Console.WriteLine(Properties.Settings.Default.txdataCodecIsVoip);
        }

        private void txdataBitrate_SelectedIndexChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.txdataBitrate = int.Parse(txdataBitrate.Text);
            Properties.Settings.Default.Save();
        }

        private void voiceBandwidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (voiceBandwidth.Text)
            {
                case "Narrow":
                    {
                        Properties.Settings.Default.voiceBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Medium":
                    {
                        Properties.Settings.Default.voiceBandwidth = OPUS_BANDWIDTH_MEDIUMBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Wideband":
                    {
                        Properties.Settings.Default.voiceBandwidth = OPUS_BANDWIDTH_WIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Superwideband":
                    {
                        Properties.Settings.Default.voiceBandwidth = OPUS_BANDWIDTH_SUPERWIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Fullband":
                    {
                        Properties.Settings.Default.voiceBandwidth = OPUS_BANDWIDTH_FULLBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                default:
                    Properties.Settings.Default.voiceBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                    Properties.Settings.Default.Save();
                    break;
            }




            byte[] VoiceBWtextstrng = StrToByteArray("VoBW" + Properties.Settings.Default.voiceBandwidth); //w3sz  convert to byte array

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(VoiceBWtextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(VoiceBWtextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(VoiceBWtextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(VoiceBWtextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(VoiceBWtextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(VoiceBWtextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(VoiceBWtextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(VoiceBWtextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void txvoiceBandwidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (txvoiceBandwidth.Text)
            {
                case "Narrow":
                    {
                        Properties.Settings.Default.txvoiceBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Medium":
                    {
                        Properties.Settings.Default.txvoiceBandwidth = OPUS_BANDWIDTH_MEDIUMBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Wideband":
                    {
                        Properties.Settings.Default.txvoiceBandwidth = OPUS_BANDWIDTH_WIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Superwideband":
                    {
                        Properties.Settings.Default.txvoiceBandwidth = OPUS_BANDWIDTH_SUPERWIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Fullband":
                    {
                        Properties.Settings.Default.txvoiceBandwidth = OPUS_BANDWIDTH_FULLBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                default:
                    Properties.Settings.Default.txvoiceBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                    Properties.Settings.Default.Save();
                    break;
            }

        }

        private void dataBandwidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (dataBandwidth.Text)
            {
                case "Narrow":
                    {
                        Properties.Settings.Default.dataBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Medium":
                    {
                        Properties.Settings.Default.dataBandwidth = OPUS_BANDWIDTH_MEDIUMBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Wideband":
                    {
                        Properties.Settings.Default.dataBandwidth = OPUS_BANDWIDTH_WIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Superwideband":
                    {
                        Properties.Settings.Default.dataBandwidth = OPUS_BANDWIDTH_SUPERWIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Fullband":
                    {
                        Properties.Settings.Default.dataBandwidth = OPUS_BANDWIDTH_FULLBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                default:
                    Properties.Settings.Default.dataBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                    Properties.Settings.Default.Save();
                    break;
            }
            byte[] DataBWtextstrng = StrToByteArray("DaBW" + Properties.Settings.Default.dataBandwidth); //w3sz  convert to byte array

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(DataBWtextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(DataBWtextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(DataBWtextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(DataBWtextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(DataBWtextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(DataBWtextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(DataBWtextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(DataBWtextstrng, _HF.w3szendpoint1, 8007);
            }

        }

        private void txdataBandwidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (txdataBandwidth.Text)
            {
                case "Narrow":
                    {
                        Properties.Settings.Default.txdataBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Medium":
                    {
                        Properties.Settings.Default.txdataBandwidth = OPUS_BANDWIDTH_MEDIUMBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Wideband":
                    {
                        Properties.Settings.Default.txdataBandwidth = OPUS_BANDWIDTH_WIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Superwideband":
                    {
                        Properties.Settings.Default.txdataBandwidth = OPUS_BANDWIDTH_SUPERWIDEBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                case "Fullband":
                    {
                        Properties.Settings.Default.txdataBandwidth = OPUS_BANDWIDTH_FULLBAND;
                        Properties.Settings.Default.Save();
                        break;
                    }
                default:
                    Properties.Settings.Default.txdataBandwidth = OPUS_BANDWIDTH_NARROWBAND;
                    Properties.Settings.Default.Save();
                    break;
            }

        }

        private void DigiCOMComboBoxAux_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for DigiCOMAux is " + DigiCOMComboBoxAux.SelectedItem.ToString());
                Properties.Settings.Default.DigiCOMAux = DigiCOMComboBoxAux.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }


        }

        private void DigitalPTTComboBoxAux_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                Console.WriteLine("The selected value for DigtalPTT Aux COM Port is " + DigitalPTTComboBoxAux.SelectedItem.ToString());
                Properties.Settings.Default.DigitalPTTCOMAux = DigitalPTTComboBoxAux.SelectedItem.ToString();
                Properties.Settings.Default.Save();
            }
            catch
            {
            }
        }

        private void RxDigAudioOutBoxAux_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (RxDigAudioOutBoxAux.SelectedIndex >= 0)
                {
                    int inum;
                    for (inum = 0; inum < Form1.RxDigAudioOutAux.Count; inum++)
                        if (RxDigAudioOutBoxAux.SelectedItem.ToString() == Form1.RxDigAudioOutAux[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.DigiWaveOutIndexAux = inum;
                            Properties.Settings.Default.Save();
                            Form1.DigiWaveOutIndexAux = inum;
                            Console.WriteLine("Aux Digi WaveOut Index in RxDigAudioInBoxAux_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("Aux Digi WaveOut Device Name in RxDigAudioOutBoxAux_SelectedIndexChanged is " + RxDigAudioOutBoxAux.SelectedItem.ToString());
                    Properties.Settings.Default.DigiRxAudioOutNameAux = RxDigAudioOutBoxAux.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("WaveOut Device Selection Failed");
            }

        }

        private void TxDigAudioInBoxAux_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (suspendUpdate)
            {
                return;
            }

            try
            {
                if (TxDigAudioInBoxAux.SelectedIndex >= 0)
                {

                    int inum;
                    for (inum = 0; inum < Form1.TxDigidevicesAux.Count; inum++)
                        if (TxDigAudioInBoxAux.SelectedItem.ToString() == Form1.TxDigidevicesAux[inum].FriendlyName.ToString())
                        {
                            Properties.Settings.Default.DigiWaveInIndexAux = inum;
                            Properties.Settings.Default.Save();
                            Form1.DigiWaveInIndexAux = inum;
                            Console.WriteLine("Aux DigiWaveIn Index in TxDigAudioInBoxAux_SelectedIndexChanged is " + inum);
                        }
                    Console.WriteLine("Aux DigiWaveIn Device Name in TxDigAudioInBoxAux_SelectedIndexChanged is " + TxDigAudioInBoxAux.SelectedItem.ToString());
                    Properties.Settings.Default.DigiTxAudioInNameAux = TxDigAudioInBoxAux.SelectedItem.ToString();
                    Properties.Settings.Default.Save();
                }
            }
            catch
            {
                Console.WriteLine("Aux WaveIn Device Selection Failed");
            }

        }

        private void opusChkBox_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.opusComp = opusChkBox.Checked;
            Properties.Settings.Default.Save();



            byte[] opusComptextstrng = StrToByteArray("Opus" + Properties.Settings.Default.opusComp); //w3sz  convert to byte array
                                                                                                      //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(opusComptextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(opusComptextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(opusComptextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(opusComptextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(opusComptextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(opusComptextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(opusComptextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(opusComptextstrng, _HF.w3szendpoint1, 8007);
            }
        }

        private void opusTxChkBox_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.opusTxComp = opusTxChkBox.Checked;
            Properties.Settings.Default.Save();



            byte[] opusTxComptextstrng = StrToByteArray("TxOp" + Properties.Settings.Default.opusTxComp); //w3sz  convert to byte array
                                                                                                      //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.GHzChecked)
            {

                sendCommandAsync(opusTxComptextstrng, MicroMHz.w3szendpoint1, 8000);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.Checked50)
            {
                sendCommandAsync(opusTxComptextstrng, _50MHz.w3szendpoint1, 8001);

            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked144)
            {
                sendCommandAsync(opusTxComptextstrng, _144MHz.w3szendpoint1, 8002);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(opusTxComptextstrng, _222MHz.w3szendpoint1, 8003);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked432)
            {
                sendCommandAsync(opusTxComptextstrng, _432MHz.w3szendpoint1, 8004);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked903)
            {
                sendCommandAsync(opusTxComptextstrng, _903MHz.w3szendpoint1, 8005);
            }


            //this is UI command sender; sends commands back to radio //w3sz
            if (Properties.Settings.Default.Checked1296)
            {
                sendCommandAsync(opusTxComptextstrng, _1296MHz.w3szendpoint1, 8006);
            }

            //this is UI command sender; sends commands back to radio //w3sz

            if (Properties.Settings.Default.HFChecked)
            {
                sendCommandAsync(opusTxComptextstrng, _HF.w3szendpoint1, 8007);
            }
        }

    }
}
